using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace ExampleApplication
{
    [global::System.AttributeUsage(AttributeTargets.Class, Inherited = false, AllowMultiple = false)]
    sealed class ViewAttribute: Attribute
    {
        private string _Name;
        private bool _AddAutomatically;

        public bool AddAutomatically
        {
            get { return _AddAutomatically; }
            set { _AddAutomatically = value; }
        }


        public string Name
        {
            get { return _Name; }
        }

        public ViewAttribute(string name)
        {
            _Name = name;
            AddAutomatically = true;
        }

        public static bool IsDefined<T>()
        {
            return IsDefined(typeof(T), typeof(ViewAttribute));
        }
        public static bool IsDefined(Type t)
        {
            return IsDefined(t, typeof(ViewAttribute));
        }

        public static ViewAttribute Get<T>() 
        {
            return (ViewAttribute) GetCustomAttribute(typeof(T), typeof(ViewAttribute));
        }

        public static ViewAttribute Get(Type type)
        {
            return (ViewAttribute) GetCustomAttribute(type, typeof(ViewAttribute));
        }

    }

}
